Index: contrib/ntp/util/ntp-keygen-opts.c
===================================================================
--- contrib/ntp/util/ntp-keygen-opts.c	(版本 314126)
+++ contrib/ntp/util/ntp-keygen-opts.c	(版本 316722)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.c)
  *
- *  It has been AutoGen-ed  November 21, 2016 at 08:03:30 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  March 21, 2017 at 10:45:48 AM by AutoGen 5.18.5
  *  From the definitions    ntp-keygen-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntp-keygen program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -51,7 +51,7 @@
 #endif
 extern FILE * option_usage_fp;
 #define zCopyright      (ntp_keygen_opt_strs+0)
-#define zLicenseDescrip (ntp_keygen_opt_strs+352)
+#define zLicenseDescrip (ntp_keygen_opt_strs+353)
 
 /*
  *  global included definitions
@@ -71,15 +71,15 @@
 /**
  *  static const strings for ntp-keygen options
  */
-static char const ntp_keygen_opt_strs[2419] =
-/*     0 */ "ntp-keygen (ntp) 4.2.8p9\n"
-            "Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n"
+static char const ntp_keygen_opt_strs[2422] =
+/*     0 */ "ntp-keygen (ntp) 4.2.8p10\n"
+            "Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
             "can be seen at:\n"
             "  <http://ntp.org/license>\n"
             "  <http://opensource.org/licenses/ntp-license.php>\n\0"
-/*   352 */ "Permission to use, copy, modify, and distribute this software and its\n"
+/*   353 */ "Permission to use, copy, modify, and distribute this software and its\n"
             "documentation for any purpose with or without fee is hereby granted,\n"
             "provided that the above copyright notice appears in all copies and that\n"
             "both the copyright notice and this permission notice appear in supporting\n"
@@ -89,89 +89,89 @@
             "Time Foundation makes no representations about the suitability this\n"
             "software for any purpose.  It is provided \"as is\" without express or\n"
             "implied warranty.\n\0"
-/*  1020 */ "identity modulus bits\0"
-/*  1042 */ "IMBITS\0"
-/*  1049 */ "imbits\0"
-/*  1056 */ "certificate scheme\0"
-/*  1075 */ "CERTIFICATE\0"
-/*  1087 */ "certificate\0"
-/*  1099 */ "privatekey cipher\0"
-/*  1117 */ "CIPHER\0"
-/*  1124 */ "cipher\0"
-/*  1131 */ "Increase debug verbosity level\0"
-/*  1162 */ "DEBUG_LEVEL\0"
-/*  1174 */ "debug-level\0"
-/*  1186 */ "Set the debug verbosity level\0"
-/*  1216 */ "SET_DEBUG_LEVEL\0"
-/*  1232 */ "set-debug-level\0"
-/*  1248 */ "Write IFF or GQ identity keys\0"
-/*  1278 */ "ID_KEY\0"
-/*  1285 */ "id-key\0"
-/*  1292 */ "Generate GQ parameters and keys\0"
-/*  1324 */ "GQ_PARAMS\0"
-/*  1334 */ "gq-params\0"
-/*  1344 */ "generate RSA host key\0"
-/*  1366 */ "HOST_KEY\0"
-/*  1375 */ "host-key\0"
-/*  1384 */ "generate IFF parameters\0"
-/*  1408 */ "IFFKEY\0"
-/*  1415 */ "iffkey\0"
-/*  1422 */ "set Autokey group name\0"
-/*  1445 */ "IDENT\0"
-/*  1451 */ "ident\0"
-/*  1457 */ "set certificate lifetime\0"
-/*  1482 */ "LIFETIME\0"
-/*  1491 */ "lifetime\0"
-/*  1500 */ "generate MD5 keys\0"
-/*  1518 */ "MD5KEY\0"
-/*  1525 */ "md5key\0"
-/*  1532 */ "modulus\0"
-/*  1540 */ "MODULUS\0"
-/*  1548 */ "generate PC private certificate\0"
-/*  1580 */ "PVT_CERT\0"
-/*  1589 */ "pvt-cert\0"
-/*  1598 */ "local private password\0"
-/*  1621 */ "PASSWORD\0"
-/*  1630 */ "password\0"
-/*  1639 */ "export IFF or GQ group keys with password\0"
-/*  1681 */ "EXPORT_PASSWD\0"
-/*  1695 */ "export-passwd\0"
-/*  1709 */ "generate sign key (RSA or DSA)\0"
-/*  1740 */ "SIGN_KEY\0"
-/*  1749 */ "sign-key\0"
-/*  1758 */ "set host and optionally group name\0"
-/*  1793 */ "SUBJECT_NAME\0"
-/*  1806 */ "subject-name\0"
-/*  1819 */ "trusted certificate (TC scheme)\0"
-/*  1851 */ "TRUSTED_CERT\0"
-/*  1864 */ "trusted-cert\0"
-/*  1877 */ "generate <num> MV parameters\0"
-/*  1906 */ "MV_PARAMS\0"
-/*  1916 */ "mv-params\0"
-/*  1926 */ "update <num> MV keys\0"
-/*  1947 */ "MV_KEYS\0"
-/*  1955 */ "mv-keys\0"
-/*  1963 */ "display extended usage information and exit\0"
-/*  2007 */ "help\0"
-/*  2012 */ "extended usage information passed thru pager\0"
-/*  2057 */ "more-help\0"
-/*  2067 */ "output version information and exit\0"
-/*  2103 */ "version\0"
-/*  2111 */ "save the option state to a config file\0"
-/*  2150 */ "save-opts\0"
-/*  2160 */ "load options from a config file\0"
-/*  2192 */ "LOAD_OPTS\0"
-/*  2202 */ "no-load-opts\0"
-/*  2215 */ "no\0"
-/*  2218 */ "NTP_KEYGEN\0"
-/*  2229 */ "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p9\n"
+/*  1021 */ "identity modulus bits\0"
+/*  1043 */ "IMBITS\0"
+/*  1050 */ "imbits\0"
+/*  1057 */ "certificate scheme\0"
+/*  1076 */ "CERTIFICATE\0"
+/*  1088 */ "certificate\0"
+/*  1100 */ "privatekey cipher\0"
+/*  1118 */ "CIPHER\0"
+/*  1125 */ "cipher\0"
+/*  1132 */ "Increase debug verbosity level\0"
+/*  1163 */ "DEBUG_LEVEL\0"
+/*  1175 */ "debug-level\0"
+/*  1187 */ "Set the debug verbosity level\0"
+/*  1217 */ "SET_DEBUG_LEVEL\0"
+/*  1233 */ "set-debug-level\0"
+/*  1249 */ "Write IFF or GQ identity keys\0"
+/*  1279 */ "ID_KEY\0"
+/*  1286 */ "id-key\0"
+/*  1293 */ "Generate GQ parameters and keys\0"
+/*  1325 */ "GQ_PARAMS\0"
+/*  1335 */ "gq-params\0"
+/*  1345 */ "generate RSA host key\0"
+/*  1367 */ "HOST_KEY\0"
+/*  1376 */ "host-key\0"
+/*  1385 */ "generate IFF parameters\0"
+/*  1409 */ "IFFKEY\0"
+/*  1416 */ "iffkey\0"
+/*  1423 */ "set Autokey group name\0"
+/*  1446 */ "IDENT\0"
+/*  1452 */ "ident\0"
+/*  1458 */ "set certificate lifetime\0"
+/*  1483 */ "LIFETIME\0"
+/*  1492 */ "lifetime\0"
+/*  1501 */ "generate MD5 keys\0"
+/*  1519 */ "MD5KEY\0"
+/*  1526 */ "md5key\0"
+/*  1533 */ "modulus\0"
+/*  1541 */ "MODULUS\0"
+/*  1549 */ "generate PC private certificate\0"
+/*  1581 */ "PVT_CERT\0"
+/*  1590 */ "pvt-cert\0"
+/*  1599 */ "local private password\0"
+/*  1622 */ "PASSWORD\0"
+/*  1631 */ "password\0"
+/*  1640 */ "export IFF or GQ group keys with password\0"
+/*  1682 */ "EXPORT_PASSWD\0"
+/*  1696 */ "export-passwd\0"
+/*  1710 */ "generate sign key (RSA or DSA)\0"
+/*  1741 */ "SIGN_KEY\0"
+/*  1750 */ "sign-key\0"
+/*  1759 */ "set host and optionally group name\0"
+/*  1794 */ "SUBJECT_NAME\0"
+/*  1807 */ "subject-name\0"
+/*  1820 */ "trusted certificate (TC scheme)\0"
+/*  1852 */ "TRUSTED_CERT\0"
+/*  1865 */ "trusted-cert\0"
+/*  1878 */ "generate <num> MV parameters\0"
+/*  1907 */ "MV_PARAMS\0"
+/*  1917 */ "mv-params\0"
+/*  1927 */ "update <num> MV keys\0"
+/*  1948 */ "MV_KEYS\0"
+/*  1956 */ "mv-keys\0"
+/*  1964 */ "display extended usage information and exit\0"
+/*  2008 */ "help\0"
+/*  2013 */ "extended usage information passed thru pager\0"
+/*  2058 */ "more-help\0"
+/*  2068 */ "output version information and exit\0"
+/*  2104 */ "version\0"
+/*  2112 */ "save the option state to a config file\0"
+/*  2151 */ "save-opts\0"
+/*  2161 */ "load options from a config file\0"
+/*  2193 */ "LOAD_OPTS\0"
+/*  2203 */ "no-load-opts\0"
+/*  2216 */ "no\0"
+/*  2219 */ "NTP_KEYGEN\0"
+/*  2230 */ "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p10\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n\0"
-/*  2343 */ "$HOME\0"
-/*  2349 */ ".\0"
-/*  2351 */ ".ntprc\0"
-/*  2358 */ "http://bugs.ntp.org, bugs@ntp.org\0"
-/*  2392 */ "\n\0"
-/*  2394 */ "ntp-keygen (ntp) 4.2.8p9";
+/*  2345 */ "$HOME\0"
+/*  2351 */ ".\0"
+/*  2353 */ ".ntprc\0"
+/*  2360 */ "http://bugs.ntp.org, bugs@ntp.org\0"
+/*  2394 */ "\n\0"
+/*  2396 */ "ntp-keygen (ntp) 4.2.8p10";
 
 /**
  *  imbits option description:
@@ -178,11 +178,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the imbits option */
-#define IMBITS_DESC      (ntp_keygen_opt_strs+1020)
+#define IMBITS_DESC      (ntp_keygen_opt_strs+1021)
 /** Upper-cased name for the imbits option */
-#define IMBITS_NAME      (ntp_keygen_opt_strs+1042)
+#define IMBITS_NAME      (ntp_keygen_opt_strs+1043)
 /** Name string for the imbits option */
-#define IMBITS_name      (ntp_keygen_opt_strs+1049)
+#define IMBITS_name      (ntp_keygen_opt_strs+1050)
 /** Compiled in flag settings for the imbits option */
 #define IMBITS_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -199,11 +199,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the certificate option */
-#define CERTIFICATE_DESC      (ntp_keygen_opt_strs+1056)
+#define CERTIFICATE_DESC      (ntp_keygen_opt_strs+1057)
 /** Upper-cased name for the certificate option */
-#define CERTIFICATE_NAME      (ntp_keygen_opt_strs+1075)
+#define CERTIFICATE_NAME      (ntp_keygen_opt_strs+1076)
 /** Name string for the certificate option */
-#define CERTIFICATE_name      (ntp_keygen_opt_strs+1087)
+#define CERTIFICATE_name      (ntp_keygen_opt_strs+1088)
 /** Compiled in flag settings for the certificate option */
 #define CERTIFICATE_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -220,11 +220,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the cipher option */
-#define CIPHER_DESC      (ntp_keygen_opt_strs+1099)
+#define CIPHER_DESC      (ntp_keygen_opt_strs+1100)
 /** Upper-cased name for the cipher option */
-#define CIPHER_NAME      (ntp_keygen_opt_strs+1117)
+#define CIPHER_NAME      (ntp_keygen_opt_strs+1118)
 /** Name string for the cipher option */
-#define CIPHER_name      (ntp_keygen_opt_strs+1124)
+#define CIPHER_name      (ntp_keygen_opt_strs+1125)
 /** Compiled in flag settings for the cipher option */
 #define CIPHER_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -240,11 +240,11 @@
  *  debug-level option description:
  */
 /** Descriptive text for the debug-level option */
-#define DEBUG_LEVEL_DESC      (ntp_keygen_opt_strs+1131)
+#define DEBUG_LEVEL_DESC      (ntp_keygen_opt_strs+1132)
 /** Upper-cased name for the debug-level option */
-#define DEBUG_LEVEL_NAME      (ntp_keygen_opt_strs+1162)
+#define DEBUG_LEVEL_NAME      (ntp_keygen_opt_strs+1163)
 /** Name string for the debug-level option */
-#define DEBUG_LEVEL_name      (ntp_keygen_opt_strs+1174)
+#define DEBUG_LEVEL_name      (ntp_keygen_opt_strs+1175)
 /** Compiled in flag settings for the debug-level option */
 #define DEBUG_LEVEL_FLAGS     (OPTST_DISABLED)
 
@@ -252,11 +252,11 @@
  *  set-debug-level option description:
  */
 /** Descriptive text for the set-debug-level option */
-#define SET_DEBUG_LEVEL_DESC      (ntp_keygen_opt_strs+1186)
+#define SET_DEBUG_LEVEL_DESC      (ntp_keygen_opt_strs+1187)
 /** Upper-cased name for the set-debug-level option */
-#define SET_DEBUG_LEVEL_NAME      (ntp_keygen_opt_strs+1216)
+#define SET_DEBUG_LEVEL_NAME      (ntp_keygen_opt_strs+1217)
 /** Name string for the set-debug-level option */
-#define SET_DEBUG_LEVEL_name      (ntp_keygen_opt_strs+1232)
+#define SET_DEBUG_LEVEL_name      (ntp_keygen_opt_strs+1233)
 /** Compiled in flag settings for the set-debug-level option */
 #define SET_DEBUG_LEVEL_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -266,11 +266,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the id-key option */
-#define ID_KEY_DESC      (ntp_keygen_opt_strs+1248)
+#define ID_KEY_DESC      (ntp_keygen_opt_strs+1249)
 /** Upper-cased name for the id-key option */
-#define ID_KEY_NAME      (ntp_keygen_opt_strs+1278)
+#define ID_KEY_NAME      (ntp_keygen_opt_strs+1279)
 /** Name string for the id-key option */
-#define ID_KEY_name      (ntp_keygen_opt_strs+1285)
+#define ID_KEY_name      (ntp_keygen_opt_strs+1286)
 /** Compiled in flag settings for the id-key option */
 #define ID_KEY_FLAGS     (OPTST_DISABLED)
 
@@ -286,11 +286,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the gq-params option */
-#define GQ_PARAMS_DESC      (ntp_keygen_opt_strs+1292)
+#define GQ_PARAMS_DESC      (ntp_keygen_opt_strs+1293)
 /** Upper-cased name for the gq-params option */
-#define GQ_PARAMS_NAME      (ntp_keygen_opt_strs+1324)
+#define GQ_PARAMS_NAME      (ntp_keygen_opt_strs+1325)
 /** Name string for the gq-params option */
-#define GQ_PARAMS_name      (ntp_keygen_opt_strs+1334)
+#define GQ_PARAMS_name      (ntp_keygen_opt_strs+1335)
 /** Compiled in flag settings for the gq-params option */
 #define GQ_PARAMS_FLAGS     (OPTST_DISABLED)
 
@@ -306,11 +306,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the host-key option */
-#define HOST_KEY_DESC      (ntp_keygen_opt_strs+1344)
+#define HOST_KEY_DESC      (ntp_keygen_opt_strs+1345)
 /** Upper-cased name for the host-key option */
-#define HOST_KEY_NAME      (ntp_keygen_opt_strs+1366)
+#define HOST_KEY_NAME      (ntp_keygen_opt_strs+1367)
 /** Name string for the host-key option */
-#define HOST_KEY_name      (ntp_keygen_opt_strs+1375)
+#define HOST_KEY_name      (ntp_keygen_opt_strs+1376)
 /** Compiled in flag settings for the host-key option */
 #define HOST_KEY_FLAGS     (OPTST_DISABLED)
 
@@ -326,11 +326,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the iffkey option */
-#define IFFKEY_DESC      (ntp_keygen_opt_strs+1384)
+#define IFFKEY_DESC      (ntp_keygen_opt_strs+1385)
 /** Upper-cased name for the iffkey option */
-#define IFFKEY_NAME      (ntp_keygen_opt_strs+1408)
+#define IFFKEY_NAME      (ntp_keygen_opt_strs+1409)
 /** Name string for the iffkey option */
-#define IFFKEY_name      (ntp_keygen_opt_strs+1415)
+#define IFFKEY_name      (ntp_keygen_opt_strs+1416)
 /** Compiled in flag settings for the iffkey option */
 #define IFFKEY_FLAGS     (OPTST_DISABLED)
 
@@ -346,11 +346,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the ident option */
-#define IDENT_DESC      (ntp_keygen_opt_strs+1422)
+#define IDENT_DESC      (ntp_keygen_opt_strs+1423)
 /** Upper-cased name for the ident option */
-#define IDENT_NAME      (ntp_keygen_opt_strs+1445)
+#define IDENT_NAME      (ntp_keygen_opt_strs+1446)
 /** Name string for the ident option */
-#define IDENT_name      (ntp_keygen_opt_strs+1451)
+#define IDENT_name      (ntp_keygen_opt_strs+1452)
 /** Compiled in flag settings for the ident option */
 #define IDENT_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -367,11 +367,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the lifetime option */
-#define LIFETIME_DESC      (ntp_keygen_opt_strs+1457)
+#define LIFETIME_DESC      (ntp_keygen_opt_strs+1458)
 /** Upper-cased name for the lifetime option */
-#define LIFETIME_NAME      (ntp_keygen_opt_strs+1482)
+#define LIFETIME_NAME      (ntp_keygen_opt_strs+1483)
 /** Name string for the lifetime option */
-#define LIFETIME_name      (ntp_keygen_opt_strs+1491)
+#define LIFETIME_name      (ntp_keygen_opt_strs+1492)
 /** Compiled in flag settings for the lifetime option */
 #define LIFETIME_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -387,11 +387,11 @@
  *  md5key option description:
  */
 /** Descriptive text for the md5key option */
-#define MD5KEY_DESC      (ntp_keygen_opt_strs+1500)
+#define MD5KEY_DESC      (ntp_keygen_opt_strs+1501)
 /** Upper-cased name for the md5key option */
-#define MD5KEY_NAME      (ntp_keygen_opt_strs+1518)
+#define MD5KEY_NAME      (ntp_keygen_opt_strs+1519)
 /** Name string for the md5key option */
-#define MD5KEY_name      (ntp_keygen_opt_strs+1525)
+#define MD5KEY_name      (ntp_keygen_opt_strs+1526)
 /** Compiled in flag settings for the md5key option */
 #define MD5KEY_FLAGS     (OPTST_DISABLED)
 
@@ -400,11 +400,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the modulus option */
-#define MODULUS_DESC      (ntp_keygen_opt_strs+1532)
+#define MODULUS_DESC      (ntp_keygen_opt_strs+1533)
 /** Upper-cased name for the modulus option */
-#define MODULUS_NAME      (ntp_keygen_opt_strs+1540)
+#define MODULUS_NAME      (ntp_keygen_opt_strs+1541)
 /** Name string for the modulus option */
-#define MODULUS_name      (ntp_keygen_opt_strs+1532)
+#define MODULUS_name      (ntp_keygen_opt_strs+1533)
 /** Compiled in flag settings for the modulus option */
 #define MODULUS_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -421,11 +421,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the pvt-cert option */
-#define PVT_CERT_DESC      (ntp_keygen_opt_strs+1548)
+#define PVT_CERT_DESC      (ntp_keygen_opt_strs+1549)
 /** Upper-cased name for the pvt-cert option */
-#define PVT_CERT_NAME      (ntp_keygen_opt_strs+1580)
+#define PVT_CERT_NAME      (ntp_keygen_opt_strs+1581)
 /** Name string for the pvt-cert option */
-#define PVT_CERT_name      (ntp_keygen_opt_strs+1589)
+#define PVT_CERT_name      (ntp_keygen_opt_strs+1590)
 /** Compiled in flag settings for the pvt-cert option */
 #define PVT_CERT_FLAGS     (OPTST_DISABLED)
 
@@ -441,11 +441,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the password option */
-#define PASSWORD_DESC      (ntp_keygen_opt_strs+1598)
+#define PASSWORD_DESC      (ntp_keygen_opt_strs+1599)
 /** Upper-cased name for the password option */
-#define PASSWORD_NAME      (ntp_keygen_opt_strs+1621)
+#define PASSWORD_NAME      (ntp_keygen_opt_strs+1622)
 /** Name string for the password option */
-#define PASSWORD_name      (ntp_keygen_opt_strs+1630)
+#define PASSWORD_name      (ntp_keygen_opt_strs+1631)
 /** Compiled in flag settings for the password option */
 #define PASSWORD_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -462,11 +462,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the export-passwd option */
-#define EXPORT_PASSWD_DESC      (ntp_keygen_opt_strs+1639)
+#define EXPORT_PASSWD_DESC      (ntp_keygen_opt_strs+1640)
 /** Upper-cased name for the export-passwd option */
-#define EXPORT_PASSWD_NAME      (ntp_keygen_opt_strs+1681)
+#define EXPORT_PASSWD_NAME      (ntp_keygen_opt_strs+1682)
 /** Name string for the export-passwd option */
-#define EXPORT_PASSWD_name      (ntp_keygen_opt_strs+1695)
+#define EXPORT_PASSWD_name      (ntp_keygen_opt_strs+1696)
 /** Compiled in flag settings for the export-passwd option */
 #define EXPORT_PASSWD_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -483,11 +483,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the sign-key option */
-#define SIGN_KEY_DESC      (ntp_keygen_opt_strs+1709)
+#define SIGN_KEY_DESC      (ntp_keygen_opt_strs+1710)
 /** Upper-cased name for the sign-key option */
-#define SIGN_KEY_NAME      (ntp_keygen_opt_strs+1740)
+#define SIGN_KEY_NAME      (ntp_keygen_opt_strs+1741)
 /** Name string for the sign-key option */
-#define SIGN_KEY_name      (ntp_keygen_opt_strs+1749)
+#define SIGN_KEY_name      (ntp_keygen_opt_strs+1750)
 /** Compiled in flag settings for the sign-key option */
 #define SIGN_KEY_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -504,11 +504,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the subject-name option */
-#define SUBJECT_NAME_DESC      (ntp_keygen_opt_strs+1758)
+#define SUBJECT_NAME_DESC      (ntp_keygen_opt_strs+1759)
 /** Upper-cased name for the subject-name option */
-#define SUBJECT_NAME_NAME      (ntp_keygen_opt_strs+1793)
+#define SUBJECT_NAME_NAME      (ntp_keygen_opt_strs+1794)
 /** Name string for the subject-name option */
-#define SUBJECT_NAME_name      (ntp_keygen_opt_strs+1806)
+#define SUBJECT_NAME_name      (ntp_keygen_opt_strs+1807)
 /** Compiled in flag settings for the subject-name option */
 #define SUBJECT_NAME_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -525,11 +525,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the trusted-cert option */
-#define TRUSTED_CERT_DESC      (ntp_keygen_opt_strs+1819)
+#define TRUSTED_CERT_DESC      (ntp_keygen_opt_strs+1820)
 /** Upper-cased name for the trusted-cert option */
-#define TRUSTED_CERT_NAME      (ntp_keygen_opt_strs+1851)
+#define TRUSTED_CERT_NAME      (ntp_keygen_opt_strs+1852)
 /** Name string for the trusted-cert option */
-#define TRUSTED_CERT_name      (ntp_keygen_opt_strs+1864)
+#define TRUSTED_CERT_name      (ntp_keygen_opt_strs+1865)
 /** Compiled in flag settings for the trusted-cert option */
 #define TRUSTED_CERT_FLAGS     (OPTST_DISABLED)
 
@@ -545,11 +545,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the mv-params option */
-#define MV_PARAMS_DESC      (ntp_keygen_opt_strs+1877)
+#define MV_PARAMS_DESC      (ntp_keygen_opt_strs+1878)
 /** Upper-cased name for the mv-params option */
-#define MV_PARAMS_NAME      (ntp_keygen_opt_strs+1906)
+#define MV_PARAMS_NAME      (ntp_keygen_opt_strs+1907)
 /** Name string for the mv-params option */
-#define MV_PARAMS_name      (ntp_keygen_opt_strs+1916)
+#define MV_PARAMS_name      (ntp_keygen_opt_strs+1917)
 /** Compiled in flag settings for the mv-params option */
 #define MV_PARAMS_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -566,11 +566,11 @@
  */
 #ifdef AUTOKEY
 /** Descriptive text for the mv-keys option */
-#define MV_KEYS_DESC      (ntp_keygen_opt_strs+1926)
+#define MV_KEYS_DESC      (ntp_keygen_opt_strs+1927)
 /** Upper-cased name for the mv-keys option */
-#define MV_KEYS_NAME      (ntp_keygen_opt_strs+1947)
+#define MV_KEYS_NAME      (ntp_keygen_opt_strs+1948)
 /** Name string for the mv-keys option */
-#define MV_KEYS_name      (ntp_keygen_opt_strs+1955)
+#define MV_KEYS_name      (ntp_keygen_opt_strs+1956)
 /** Compiled in flag settings for the mv-keys option */
 #define MV_KEYS_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -585,11 +585,11 @@
 /*
  *  Help/More_Help/Version option descriptions:
  */
-#define HELP_DESC       (ntp_keygen_opt_strs+1963)
-#define HELP_name       (ntp_keygen_opt_strs+2007)
+#define HELP_DESC       (ntp_keygen_opt_strs+1964)
+#define HELP_name       (ntp_keygen_opt_strs+2008)
 #ifdef HAVE_WORKING_FORK
-#define MORE_HELP_DESC  (ntp_keygen_opt_strs+2012)
-#define MORE_HELP_name  (ntp_keygen_opt_strs+2057)
+#define MORE_HELP_DESC  (ntp_keygen_opt_strs+2013)
+#define MORE_HELP_name  (ntp_keygen_opt_strs+2058)
 #define MORE_HELP_FLAGS (OPTST_IMM | OPTST_NO_INIT)
 #else
 #define MORE_HELP_DESC  HELP_DESC
@@ -602,14 +602,14 @@
 #  define VER_FLAGS     (OPTST_SET_ARGTYPE(OPARG_TYPE_STRING) | \
                          OPTST_ARG_OPTIONAL | OPTST_IMM | OPTST_NO_INIT)
 #endif
-#define VER_DESC        (ntp_keygen_opt_strs+2067)
-#define VER_name        (ntp_keygen_opt_strs+2103)
-#define SAVE_OPTS_DESC  (ntp_keygen_opt_strs+2111)
-#define SAVE_OPTS_name  (ntp_keygen_opt_strs+2150)
-#define LOAD_OPTS_DESC     (ntp_keygen_opt_strs+2160)
-#define LOAD_OPTS_NAME     (ntp_keygen_opt_strs+2192)
-#define NO_LOAD_OPTS_name  (ntp_keygen_opt_strs+2202)
-#define LOAD_OPTS_pfx      (ntp_keygen_opt_strs+2215)
+#define VER_DESC        (ntp_keygen_opt_strs+2068)
+#define VER_name        (ntp_keygen_opt_strs+2104)
+#define SAVE_OPTS_DESC  (ntp_keygen_opt_strs+2112)
+#define SAVE_OPTS_name  (ntp_keygen_opt_strs+2151)
+#define LOAD_OPTS_DESC     (ntp_keygen_opt_strs+2161)
+#define LOAD_OPTS_NAME     (ntp_keygen_opt_strs+2193)
+#define NO_LOAD_OPTS_name  (ntp_keygen_opt_strs+2203)
+#define LOAD_OPTS_pfx      (ntp_keygen_opt_strs+2216)
 #define LOAD_OPTS_name     (NO_LOAD_OPTS_name + 3)
 /**
  *  Declare option callback procedures
@@ -960,24 +960,24 @@
 
 /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
 /** Reference to the upper cased version of ntp-keygen. */
-#define zPROGNAME       (ntp_keygen_opt_strs+2218)
+#define zPROGNAME       (ntp_keygen_opt_strs+2219)
 /** Reference to the title line for ntp-keygen usage. */
-#define zUsageTitle     (ntp_keygen_opt_strs+2229)
+#define zUsageTitle     (ntp_keygen_opt_strs+2230)
 /** ntp-keygen configuration file name. */
-#define zRcName         (ntp_keygen_opt_strs+2351)
+#define zRcName         (ntp_keygen_opt_strs+2353)
 /** Directories to search for ntp-keygen config files. */
 static char const * const apzHomeList[3] = {
-    ntp_keygen_opt_strs+2343,
-    ntp_keygen_opt_strs+2349,
+    ntp_keygen_opt_strs+2345,
+    ntp_keygen_opt_strs+2351,
     NULL };
 /** The ntp-keygen program bug email address. */
-#define zBugsAddr       (ntp_keygen_opt_strs+2358)
+#define zBugsAddr       (ntp_keygen_opt_strs+2360)
 /** Clarification/explanation of what ntp-keygen does. */
-#define zExplain        (ntp_keygen_opt_strs+2392)
+#define zExplain        (ntp_keygen_opt_strs+2394)
 /** Extra detail explaining what ntp-keygen does. */
 #define zDetail         (NULL)
 /** The full version string for ntp-keygen. */
-#define zFullVersion    (ntp_keygen_opt_strs+2394)
+#define zFullVersion    (ntp_keygen_opt_strs+2396)
 /* extracted from optcode.tlib near line 364 */
 
 #if defined(ENABLE_NLS)
@@ -1309,8 +1309,8 @@
      translate option names.
    */
   /* referenced via ntp_keygenOptions.pzCopyright */
-  puts(_("ntp-keygen (ntp) 4.2.8p9\n\
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("ntp-keygen (ntp) 4.2.8p10\n\
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -1408,7 +1408,7 @@
   puts(_("load options from a config file"));
 
   /* referenced via ntp_keygenOptions.pzUsageTitle */
-  puts(_("ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p9\n\
+  puts(_("ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p10\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n"));
 
   /* referenced via ntp_keygenOptions.pzExplain */
@@ -1415,7 +1415,7 @@
   puts(_("\n"));
 
   /* referenced via ntp_keygenOptions.pzFullVersion */
-  puts(_("ntp-keygen (ntp) 4.2.8p9"));
+  puts(_("ntp-keygen (ntp) 4.2.8p10"));
 
   /* referenced via ntp_keygenOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
Index: contrib/ntp/util/ntp-keygen.c
===================================================================
--- contrib/ntp/util/ntp-keygen.c	(版本 314126)
+++ contrib/ntp/util/ntp-keygen.c	(版本 316722)
@@ -98,11 +98,15 @@
 #include "ntp-keygen-opts.h"
 
 #ifdef OPENSSL
+#include "openssl/asn1.h"
 #include "openssl/bn.h"
+#include "openssl/crypto.h"
 #include "openssl/evp.h"
 #include "openssl/err.h"
 #include "openssl/rand.h"
+#include "openssl/opensslv.h"
 #include "openssl/pem.h"
+#include "openssl/x509.h"
 #include "openssl/x509v3.h"
 #include <openssl/objects.h>
 #include "libssl_compat.h"
@@ -326,6 +330,10 @@
 	int	i, cnt;
 	char *	ptr;
 #endif	/* AUTOKEY */
+#ifdef OPENSSL
+	const char *sslvtext;
+	int sslvmatch;
+#endif /* OPENSSL */
 
 	progname = argv[0];
 
@@ -363,12 +371,14 @@
 	argv += optct;	// Just in case we care later.
 
 #ifdef OPENSSL
-	if (SSLeay() == SSLEAY_VERSION_NUMBER)
+	sslvtext = OpenSSL_version(OPENSSL_VERSION);
+	sslvmatch = OpenSSL_version_num() == OPENSSL_VERSION_NUMBER;
+	if (sslvmatch)
 		fprintf(stderr, "Using OpenSSL version %s\n",
-			SSLeay_version(SSLEAY_VERSION));
+			sslvtext);
 	else
 		fprintf(stderr, "Built against OpenSSL %s, using version %s\n",
-			OPENSSL_VERSION_TEXT, SSLeay_version(SSLEAY_VERSION));
+			OPENSSL_VERSION_TEXT, sslvtext);
 #endif /* OPENSSL */
 
 	debug = OPT_VALUE_SET_DEBUG_LEVEL;
@@ -464,8 +474,10 @@
 	/*
 	 * Seed random number generator and grow weeds.
 	 */
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
 	ERR_load_crypto_strings();
 	OpenSSL_add_all_algorithms();
+#endif /* OPENSSL_VERSION_NUMBER */
 	if (!RAND_status()) {
 		if (RAND_file_name(pathbuf, sizeof(pathbuf)) == NULL) {
 			fprintf(stderr, "RAND_file_name %s\n",
@@ -1970,8 +1982,8 @@
 	ASN1_INTEGER_set(serial, (long)epoch + JAN_1970);
 	X509_set_serialNumber(cert, serial);
 	ASN1_INTEGER_free(serial);
-	X509_time_adj(X509_get_notBefore(cert), 0L, &epoch);
-	X509_time_adj(X509_get_notAfter(cert), lifetime * SECSPERDAY, &epoch);
+	X509_time_adj(X509_getm_notBefore(cert), 0L, &epoch);
+	X509_time_adj(X509_getm_notAfter(cert), lifetime * SECSPERDAY, &epoch);
 	subj = X509_get_subject_name(cert);
 	X509_NAME_add_entry_by_txt(subj, "commonName", MBSTRING_ASC,
 	    (u_char *)name, -1, -1, 0);
Index: sys/conf/newvers.sh
===================================================================
--- sys/conf/newvers.sh	(版本 314126)
+++ sys/conf/newvers.sh	(版本 316722)
@@ -32,7 +32,7 @@
 
 TYPE="FreeBSD"
 REVISION="10.3"
-BRANCH="RELEASE-p17"
+BRANCH="RELEASE-p18"
 if [ "X${BRANCH_OVERRIDE}" != "X" ]; then
 	BRANCH=${BRANCH_OVERRIDE}
 fi
Index: sys/xen/xen-os.h
===================================================================
--- sys/xen/xen-os.h	(版本 314126)
+++ sys/xen/xen-os.h	(版本 316722)
@@ -57,6 +57,8 @@
 extern int xen_disable_pv_nics;
 #endif
 
+extern bool xen_suspend_cancelled;
+
 enum xen_domain_type {
 	XEN_NATIVE,             /* running on bare hardware    */
 	XEN_PV_DOMAIN,          /* running in a PV domain      */
Index: usr.sbin/ntp/config.h
===================================================================
--- usr.sbin/ntp/config.h	(版本 314126)
+++ usr.sbin/ntp/config.h	(版本 316722)
@@ -1344,8 +1344,7 @@
 /* Should we align with the NIST lockclock scheme? */
 /* #undef LOCKCLOCK */
 
-/* Define to the sub-directory in which libtool stores uninstalled libraries.
-   */
+/* Define to the sub-directory where libtool stores uninstalled libraries. */
 #define LT_OBJDIR ".libs/"
 
 /* Does the target support multicast IP? */
@@ -1449,7 +1448,7 @@
 #define PACKAGE_NAME "ntp"
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "ntp 4.2.8p9"
+#define PACKAGE_STRING "ntp 4.2.8p10"
 
 /* Define to the one symbol short name of this package. */
 #define PACKAGE_TARNAME "ntp"
@@ -1458,7 +1457,7 @@
 #define PACKAGE_URL "http://www.ntp.org./"
 
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "4.2.8p9"
+#define PACKAGE_VERSION "4.2.8p10"
 
 /* data dir */
 #define PERLLIBDIR "/usr/local/share/ntp/lib"
@@ -1639,7 +1638,7 @@
 /* #undef USE_UDP_SIGPOLL */
 
 /* Version number of package */
-#define VERSION "4.2.8p9"
+#define VERSION "4.2.8p10"
 
 /* vsnprintf expands "%m" to strerror(errno) */
 /* #undef VSNPRINTF_PERCENT_M */
@@ -1816,5 +1815,5 @@
 /*
  * FreeBSD specific: Explicitly specify date/time for reproducible build.
  */
-#define	MKREPRO_DATE "Nov 22 2016"
-#define	MKREPRO_TIME "06:54:45"
+#define	MKREPRO_DATE "Mar 22 2017"
+#define	MKREPRO_TIME "05:40:15"
Index: usr.sbin/ntp/scripts/mkver
===================================================================
--- usr.sbin/ntp/scripts/mkver	(版本 314126)
+++ usr.sbin/ntp/scripts/mkver	(版本 316722)
@@ -6,7 +6,7 @@
 
 ConfStr="$PROG"
 
-ConfStr="$ConfStr 4.2.8p9"
+ConfStr="$ConfStr 4.2.8p10"
 
 case "$CSET" in
  '') ;;
